
let () =
  let x = Term.var (Term.fresh ()) in
  let y = Term.var (Term.fresh ()) in
  let s = Term.save () in
    assert (not (Term.equals x y)) ;
    Unify.unify x y ;
    assert (Term.equals x y) ;
    Term.restore s ;
    assert (not (Term.equals x y))

let () =
  let y = Term.var (Term.fresh ()) in
  let x = Term.var (Term.fresh ()) in
  let s = Term.save () in
    assert (not (Term.equals x y)) ;
    Unify.unify x y ;
    assert (Term.equals x y) ;
    Term.restore s ;
    assert (not (Term.equals x y))

let () =
  let x = Term.var (Term.fresh ()) in
  let t = Term.make "s" [x] in
  let s = Term.save () in
    try Unify.unify x t ; Term.restore s with
      | Unify.Unification_failure -> assert false

let () =
  let x = Term.var (Term.fresh ()) in
  let y = Term.var (Term.fresh ()) in
  let z = Term.var (Term.fresh ()) in
  let t = Term.make "f" [x; Term.make "s" [y]] in
  let u = Term.make "f" [z;z] in
    Unify.unify t u ;
    assert (Term.equals t u)

let () =
  Printf.printf "[OK] Unify\n"
